
/*++

:

	sdttest.c

:

	   Native API   
	     GetProcAddress

	   x86 

	Copyright (c) Fur, 2007

	   :
	ntinside.narod.ru

	        
	

--*/


#include <tchar.h>
#include <windows.h>
#include <stdio.h>



#ifndef _NTDEF_

typedef LONG NTSTATUS;

typedef struct _UNICODE_STRING {
    USHORT Length;
    USHORT MaximumLength;
#ifdef MIDL_PASS
    [size_is(MaximumLength / 2), length_is((Length) / 2) ] USHORT * Buffer;
#else // MIDL_PASS
    PWSTR  Buffer;
#endif // MIDL_PASS
} UNICODE_STRING;
typedef UNICODE_STRING *PUNICODE_STRING;


//
// Valid values for the Attributes field
//

#define OBJ_INHERIT             0x00000002L
#define OBJ_PERMANENT           0x00000010L
#define OBJ_EXCLUSIVE           0x00000020L
#define OBJ_CASE_INSENSITIVE    0x00000040L
#define OBJ_OPENIF              0x00000080L
#define OBJ_OPENLINK            0x00000100L
#define OBJ_KERNEL_HANDLE       0x00000200L
#define OBJ_FORCE_ACCESS_CHECK  0x00000400L
#define OBJ_VALID_ATTRIBUTES    0x000007F2L


typedef struct _OBJECT_ATTRIBUTES {
    ULONG Length;
    HANDLE RootDirectory;
    PUNICODE_STRING ObjectName;
    ULONG Attributes;
    PVOID SecurityDescriptor;        // Points to type SECURITY_DESCRIPTOR
    PVOID SecurityQualityOfService;  // Points to type SECURITY_QUALITY_OF_SERVICE
} OBJECT_ATTRIBUTES;


#define InitializeObjectAttributes( p, n, a, r, s ) { \
    (p)->Length = sizeof( OBJECT_ATTRIBUTES );          \
    (p)->RootDirectory = r;                             \
    (p)->Attributes = a;                                \
    (p)->ObjectName = n;                                \
    (p)->SecurityDescriptor = s;                        \
    (p)->SecurityQualityOfService = NULL;               \
    }

// NTSYSAPI
// VOID
// NTAPI
// RtlInitUnicodeString(
//     PUNICODE_STRING DestinationString,
//     PCWSTR SourceString
//     );

#define RtlInitUnicodeString( DestinationString, SourceString ) {\
	(DestinationString)->MaximumLength = wcslen(SourceString) * sizeof(WCHAR); \
	(DestinationString)->Length = (DestinationString)->MaximumLength; \
	(DestinationString)->Buffer = SourceString;	 \
	}


typedef enum _KEY_INFORMATION_CLASS {
    KeyBasicInformation,
    KeyNodeInformation,
    KeyFullInformation
// end_wdm
    ,
    KeyNameInformation,
    KeyCachedInformation,
    KeyFlagsInformation
// begin_wdm
} KEY_INFORMATION_CLASS;


typedef struct _KEY_BASIC_INFORMATION {
    LARGE_INTEGER LastWriteTime;
    ULONG   TitleIndex;
    ULONG   NameLength;
    WCHAR   Name[1];            // Variable length string
} KEY_BASIC_INFORMATION, *PKEY_BASIC_INFORMATION;


#endif // _NTDEF_






//
//   ,    -   NtOpenKey  NtCloseKey  API 
//   ,    Windows XP
//

VOID
SdtSimpleTestNtOpenKeyNtCloseKeyWindowsXP(
	)
{
	UNICODE_STRING		KeyName;
	OBJECT_ATTRIBUTES	ObjectAttributes;
	NTSTATUS			Status;
	ACCESS_MASK			DesiredAccess = GENERIC_READ;
	HANDLE				KeyHandle;

	//
	//     HKEY_LOCAL_MACHINE\SOFTWARE.
	//  RtlInitUnicodeString -   
	//
	RtlInitUnicodeString( &KeyName, L"\\REGISTRY\\MACHINE\\SOFTWARE" );

	//
	//   OBJECT_ATTRIBUTES.
	//  InitializeObjectAttributes -   
	//
	InitializeObjectAttributes( &ObjectAttributes, &KeyName, OBJ_CASE_INSENSITIVE, NULL, NULL );

//  
//     :
//   
// 	NTSYSAPI
// 	NTSTATUS
// 	NTAPI
// 	ZwOpenKey(
// 		OUT PHANDLE KeyHandle,
// 		IN ACCESS_MASK DesiredAccess,
// 		IN POBJECT_ATTRIBUTES ObjectAttributes
// 		);

	__asm{
		lea eax, ObjectAttributes	;  ObjectAttributes
		push eax					;   
		mov eax, DesiredAccess		;  ( )
		push eax					;   
		lea eax, KeyHandle			;  KeyHandle (    )
		push eax					;   
		
		;     ntdll.dll Windows 2000
		mov eax, 119d				;    SDT (   eax) ( XP  119)
		lea edx, [esp]				;  Windows 2000   [esp + DWORD PTR 4]
									;      (   edx)
		int 2Eh						;   -    .    
		mov Status, eax				;     eax     (NTSTATUS)
						
		; ,   __stdcall (     ),  
		;   ""  .  3  => pop  3 
		pop eax
		pop eax
		pop eax

		;    -,  add esp, 12d
	}

	//
	//    Status    
	//
	
	if ( Status != 0 )
		return;


//
//     .  ZwClose.    :
//
// 	NTSYSAPI
// 	NTSTATUS
// 	NTAPI
// 	ZwClose(
// 		IN HANDLE Handle
// 		);
	
	__asm{
		mov eax, KeyHandle         ;  
		push eax	               ;    

		mov eax, 25d               ;   eax     SDT
		lea edx, [esp]             ;  edx -  

		int 2Eh                    ;  
		mov Status, eax            ;   

		pop eax                    ;  
	}
};



//
//   .        
//
BOOL
SdtTestServicePresent(
	IN ULONG Number 
	)
{
	NTSTATUS Status = 0;

	__asm{
		mov eax, Number            ;   eax     SDT
		;lea edx, [esp]             ;  edx -  
		mov edx, 0

		int 2Eh                    ;  
		mov Status, eax            ;   .  AV
		                           ; EIP   8   4 ,  
								   ;    
	}

	// STATUS_INVALID_SYSTEM_SERVICE = 0xc000001c
	if ( Status == 0xc000001c )
		return FALSE;

	return TRUE;
}




typedef enum
{
	SystemWindows2000 = 0,
	SystemWindowsXP,
	SystemWindows2003,
	SystemWindowsVista,
	SystemWindowsUnknown
} SDT_SYSTEM;





//
//   .   
//
SDT_SYSTEM
SdtTestGetOsVersion()
{

	//    SDT:
	// 2000:  247
	// XP:    282
	// 2003:  295 
	// Vista: 390

	if ( SdtTestServicePresent( 390 ) )
		return SystemWindowsVista;

	if ( SdtTestServicePresent( 295 ) )
		return SystemWindows2003;

	if ( SdtTestServicePresent( 282 ) )
		return SystemWindowsXP;

	if ( SdtTestServicePresent( 247 ) )
		return SystemWindows2000;

	return SystemWindowsUnknown;
}




//
//   .     
//


typedef struct  
{
	ULONG Windows2000;
	ULONG WindowsXP;
	ULONG Windows2003;
	ULONG WindowsVista;
	ULONG Reserved;
} SDT_NUMBER;


ULONG
SdtNumber(
	SDT_SYSTEM System,
	SDT_NUMBER *Numbers
	)
{
	return ((ULONG*) Numbers)[System];
}


#define PROLOG_CODE( Win2000, WinXP, Win2003, WinVista ) \
	SDT_NUMBER Numbers = { Win2000, WinXP, Win2003, WinVista, -1 }; \
	ULONG Number = SdtNumber( System, &Numbers );

#define EPILOG_CODE( PopBytes ) \
	__asm mov eax, Number			  \
	__asm lea edx, [esp]			  \
	__asm int 2Eh					  \
	__asm mov Status, eax			  \
	__asm add esp, PopBytes

#define PUSH_POINTER( Pointer ) \
	__asm lea eax, Pointer			\
	__asm push eax

#define PUSH_VALUE( Value ) \
	__asm mov eax, Value \
	__asm push eax


#define ZwOpenKeyCall( System, Status, KeyHandle, DesiredAccess, ObjectAttibutes ) { \
	PROLOG_CODE( 103, 119, 125, 189 ) \
	PUSH_POINTER(ObjectAttributes) \
	PUSH_VALUE( DesiredAccess ) \
	PUSH_POINTER( KeyHandle ) \
	EPILOG_CODE( 12 ) }


#define ZwCloseHandleCall( System, Status, Handle ) { \
	PROLOG_CODE( 24,25,27,48 ) \
	PUSH_VALUE( Handle ) \
	EPILOG_CODE( 4 ) }


/*NTSYSAPI
NTSTATUS
NTAPI
ZwEnumerateKey(
    IN HANDLE KeyHandle,
    IN ULONG Index,
    IN KEY_INFORMATION_CLASS KeyInformationClass,
    OUT PVOID KeyInformation,
    IN ULONG Length,
    OUT PULONG ResultLength
    );*/

#define ZwEnumerateKeyCall( System, Status, \
	KeyHandle, Index, KeyInformationClass, KeyInformation, \
	Length, ResultLength ) { \
	PROLOG_CODE( 60,71,75,133) \
	PUSH_POINTER( ResultLength ) \
	PUSH_VALUE( Length ) \
	PUSH_POINTER( KeyInformation ) \
	PUSH_VALUE( KeyInformationClass ) \
	PUSH_VALUE( Index ) \
	PUSH_VALUE( KeyHandle ) \
	EPILOG_CODE( 24 ) }


VOID
SdtTestEnumerateSoftwareSubkeys(
	)
{
	SDT_SYSTEM System = SdtTestGetOsVersion();
	NTSTATUS Status;
	HANDLE hKey;
	OBJECT_ATTRIBUTES ObjectAttributes;
	UNICODE_STRING KeyName;
	LPWSTR szKey = L"\\REGISTRY\\MACHINE\\SOFTWARE";


	RtlInitUnicodeString( &KeyName, szKey );
	InitializeObjectAttributes( &ObjectAttributes, &KeyName, OBJ_CASE_INSENSITIVE, NULL, NULL );

	_tprintf( _T("Key: %S\n"), szKey );

	ZwOpenKeyCall( System, Status, hKey, GENERIC_READ, ObjectAttributes );

	if ( Status == 0 )
	{
		UCHAR Buffer[1024];
		PKEY_BASIC_INFORMATION pKeyInfo = (PKEY_BASIC_INFORMATION) Buffer;
		ULONG i = 0;
		

		while ( Status == 0 )
		{
			ULONG uSize = sizeof( Buffer );
			ULONG uRetSize = 0;

			ZeroMemory( Buffer, sizeof(Buffer) );

			ZwEnumerateKeyCall( System, Status, hKey, i, KeyBasicInformation, Buffer, uSize, uRetSize );

			if ( Status == 0 )
			{
				
				_tprintf( _T("Subkey[%i]: %S\n"), i, pKeyInfo->Name );
			}

			i++;

		}

		ZwCloseHandleCall( System, Status, hKey );
	}
	else
	{
		_tprintf( _T("-Can't open key. Status = 0x%.8X\n"), Status );
	}

}



_tmain()
{
	//
	//     
	//
	
	
	
	/*{
		SdtSimpleTestNtOpenKeyNtCloseKeyWindowsXP();
	}*/

	{
		SDT_SYSTEM System = SdtTestGetOsVersion();

		if ( System == SystemWindows2000 )
			_tprintf( _T("System: Windows 2000\n") );

		if ( System == SystemWindowsXP )
			_tprintf( _T("System: Windows XP\n") );

		if ( System == SystemWindows2003 )
			_tprintf( _T("System: Windows 2003\n") );

		if ( System == SystemWindowsVista )
			_tprintf( _T("System: Windows Vista\n") );
	}


	SdtTestEnumerateSoftwareSubkeys();

	return 0;
}

